#include <string>
#include <iostream>

#include <boost/program_options.hpp>
#include <boost/thread.hpp>
#include <boost/bind.hpp>

#include <windows.h>
#include <shellapi.h>
#include "saori.h"

void empty_ryc(int option,HWND hwnd)
{	
	bool res = SUCCEEDED(SHEmptyRecycleBin(0,_T(""),option));
	
	if (hwnd != INVALID_HANDLE_VALUE)
	{
		COPYDATASTRUCT cs;
		cs.dwData = 9801;
		
		if (res)
			cs.lpData = "NOTIFY SSTP/1.1\r\n" \
						"Sender: gomi\r\n" \
						"Event: OnRecycleBinEmptied\r\n" \
						"Charset: Shift_JIS\r\n" \
						"Reference0: 1\r\n" \
						"\r\n";
		else
			cs.lpData = "NOTIFY SSTP/1.1\r\n" \
						"Sender: gomi\r\n" \
						"Event: OnRecycleBinEmptied\r\n" \
						"Charset: Shift_JIS\r\n" \
						"Reference0: 0\r\n" \
						"\r\n";
		cs.cbData = static_cast<DWORD>(strlen((char*)cs.lpData));
		SendMessage(hwnd,WM_COPYDATA,(WPARAM)0,(LPARAM)&cs);
	}
	return;
}

class state
{
	public:
		std::set<std::string> table;
		HWND hwnd;
		bool verbose;
		
		state():hwnd((HWND)INVALID_HANDLE_VALUE),verbose(true){};
};

class parser
{
	private:
		bool hwnd_flag;
	public:
		typedef std::pair<std::string, std::string> result_type;
		parser(void):hwnd_flag(false){};
		
		result_type operator()(const std::string& arg,state& stat)
		{
			std::set<std::string> &table = stat.table;
			std::pair<std::string, std::string> res;
			if (hwnd_flag)
			{
				res.first = "hwnd";
				res.second = arg;
				stat.hwnd = reinterpret_cast<HWND>(conv<unsigned long long>(arg));
				hwnd_flag = false;
				return res;
			}
			std::string s = arg;
			size_t cnt = s.find_first_not_of('-');
			s = s.erase(0,cnt);

			if(cnt == 1)
			{
				for (size_t i=0;i<s.length();i++)
				{
					switch(s[i])
					{
						case 'e': table.insert("empty"); break;
						case 'n': table.insert("number-of-items"); break;
						case 'V': table.insert("version"); break;
						case 'a': table.insert("asynchronous"); break;
						case 'f': table.insert("force"); break;
						case 'q': table.insert("quiet"); stat.verbose = false; break;
						case 's': table.insert("silent"); break;
						case 'v': table.insert("verbose"); stat.verbose = true; break;
						case 'w': table.insert("hwnd"); hwnd_flag = true; break;
						case '=': goto long_break;
						default:
							// ߕs\G[ɂ
							res.first = s;
							return res;
					}
				}
				long_break:
				;
			}
			else if (cnt == 2)
			{
				if(table.count(s)>0)
				{
					// ȂɂȂ
				}
				else
				{
					table.insert(s);
					if (s.compare("hwnd") != 0)
						res.first = s;
					else
						hwnd_flag = true;
				}
			}
			else
			{
				// -ȂC3ȏ̓͂
				res.first = "invalid input";
			}
			
			if (hwnd_flag)
			{
				s = arg;
				int pos = (int)s.find_first_of('=');
				if (pos >= 0)
				{
					res.first = "hwnd";
					res.second = s.substr(pos+1);
					stat.hwnd = reinterpret_cast<HWND>(conv<unsigned long long>(res.second));
					hwnd_flag = false;
				}
			}

			return res;
		};

};

boost::thread* thr = 0;

SAORIResult execute(const SAORIInput & in, SAORIOutput & out)
{
    using namespace boost::program_options;
    
    options_description opt("option");
    // ̏`
    opt.add_options()
        ("empty,e", "S~ɂiftHgj")
        ("number-of-items,n",  "S~ɂt@C̐BRef0ɃoCg")
        ("version,V",  "o[W")
        ("asynchronous,a",  "񓯊s")
        ("force,f",  "mF_CAOoȂ")
        ("quiet,q",  "vOXo[oȂ")
        ("silent,s",  "oȂ")
		("verbose,v", "vOXo[o")
        ("hwnd,w", value<unsigned long long>()->default_value(-1), "񓯊s̎DSSTP NotifyOnRecycleBinEmptied𑗂");
		//("dummy", value<std::vector<int> >());

    // ̏ɏ]ĎۂɎw肳ꂽR}hC

    variables_map argmap;
    state stat;
    std::vector<string_t> param;
    try{
		store(boost::program_options::wcommand_line_parser(in.args)
			.options(opt).style(command_line_style::allow_sticky).extra_parser(boost::bind(parser(),_1,boost::ref(stat))).run(), argmap);
	}
	catch(std::exception &e)
	{
		out.result = conv<string_t>(e.what());
		return SAORIRESULT_INTERNAL_SERVER_ERROR;
	}
	notify(argmap);

    if (stat.table.count("version"))
    {
        out.result = conv<string_t>(_T("Ver.1.0"));
        return SAORIRESULT_OK;
    }                                                           

    if (stat.table.count("number-of-items"))
    {
        SHQUERYRBINFO sq;
        sq.cbSize = sizeof(sq);
        
        SHQueryRecycleBin(_T(""),&sq);

        out.result = conv<string_t>(sq.i64NumItems);
        out.values.push_back(conv<string_t>(sq.i64Size));
        return SAORIRESULT_OK;
    }
	
	// versionłnumberłȂ΃S~
	
	DWORD option = 0;
	option |= stat.table.count("force") ? SHERB_NOCONFIRMATION : 0;
	option |= (!stat.verbose) ? SHERB_NOPROGRESSUI : 0;
	option |= stat.table.count("silent") ? SHERB_NOSOUND : 0;
	
	if (stat.table.count("asynchronous"))
	{
		// O̔񓯊scĂI܂ő҂
		if (thr != 0)
		{
			thr->join();
			delete thr;
		}
		thr = new boost::thread(boost::bind(empty_ryc,option,stat.hwnd));
		out.result = conv<string_t>(1);
	}
	else if(SUCCEEDED(SHEmptyRecycleBin(0,_T(""),option)))
	{
		out.result = conv<string_t>(1);	
	}
	else
	{
		out.result = conv<string_t>(0);	
	}
		
	return SAORIRESULT_OK;
}

bool SAORI::load()
{
    return true;
}


bool SAORI::unload()
{
    if (thr != 0)
    {
		thr->join();
		delete thr;
    }
    return true;
}